//
//  SLTColoredButtonCell.m
//
//  Snow 
//	Leopard 
//	Test
// disclamer: i did not invent this code
// http://www.cocoadev.com/index.pl?CCDColoredButtonCell

#import "SLTColoredButtonCell.h"



@implementation SLTColoredButtonCell 
#pragma mark Button Color Methods

- (NSColor *)buttonColor {
	return buttonColor;
}

-(void)setButtonColor:(NSColor *)color {
	
	[buttonColor release];
	buttonColor = [color copy];
}


#pragma mark Draw Frame Method
- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView {
	
	if (!buttonColor || ([buttonColor isEqualTo:[NSColor clearColor]])) {
		[super drawWithFrame:cellFrame inView:controlView];
		return;
	}


	NSRect canvasFrame = NSMakeRect(0, 0, cellFrame.size.width, cellFrame.size.height);
	
	NSImage *finalImage = [[NSImage alloc] initWithSize:cellFrame.size];
	NSImage *colorImage = [[NSImage alloc] initWithSize:cellFrame.size];
	NSImage *cellImage = [[NSImage alloc] initWithSize:cellFrame.size];
	
	[finalImage setFlipped:[controlView isFlipped]];
	
	// Draw the cell into an image
	[cellImage lockFocus];
	[super drawBezelWithFrame:canvasFrame inView:[NSView focusView]];
	
	[cellImage unlockFocus];
	
	// Draw the color but only over the opaque parts of the cell image
	[colorImage lockFocus];
	[cellImage drawAtPoint:NSZeroPoint 
				  fromRect:canvasFrame 
				 operation:NSCompositeSourceOver
				  fraction:1];
	
	[buttonColor set];
	NSRectFillUsingOperation(canvasFrame, NSCompositeSourceIn);
	[colorImage unlockFocus];
	
	// Mix the colored overlay with the cell image using CompositePlusDarker
	[finalImage lockFocus];
	[colorImage drawAtPoint:NSZeroPoint 
				   fromRect:canvasFrame 
				  operation:NSCompositeSourceOver
				   fraction:1];
	[cellImage drawAtPoint:NSZeroPoint 
				  fromRect:canvasFrame 
				 operation:NSCompositePlusDarker
				  fraction:1];
	[finalImage unlockFocus];
	
	// Draw the final image to the screen
	[finalImage drawAtPoint:cellFrame.origin 
				   fromRect:canvasFrame
				  operation:NSCompositeSourceOver 
				   fraction:1];
	
	[cellImage release];
	[colorImage release];
	[finalImage release];

}

#pragma mark Array and Button Change
-(void) awakeFromNib {
	colorArray = [[NSMutableArray alloc] init];
	
	[colorArray addObject:[NSColor greenColor]];
	[colorArray addObject:[NSColor redColor]];
	[colorArray addObject:[NSColor orangeColor]];
	[colorArray addObject:[NSColor purpleColor]];
	[colorArray addObject:[NSColor clearColor]]; // arrayIndex >= 5
	[colorArray addObject:[NSColor clearColor]]; // arrayIndex >= 6
	
	

	
	arrayIndex = 0;
}

-(void)buttonCellClicked:(NSButton *)sender {
	[self setButtonColor:[colorArray objectAtIndex:arrayIndex]];
	arrayIndex ++;
	if (arrayIndex >= 5){
		[self setButtonColor:[NSColor clearColor]];
		[self setBordered:NO];
		[self setImage:[NSImage imageNamed:@"Warning.png"]];
	}
	if (arrayIndex >= 6) {
		[self setImage:nil];
		[self setBordered:YES];
	}
	if (arrayIndex >= [colorArray count]) {
		arrayIndex = 0;
	}
}
 

@end
